Subject: Re: igmp: possible NULL dereference after GFP_ATOMIC allocation?

From: Jarek Poplawski <[email-masked]>
Date: Wed, 31 Jan 2007 10:39:09 +0100

On 30-01-2007 16:04, Alexey Dobriyan wrote:
> On Tue, Jan 30, 2007 at 03:34:18AM -0800, David Stevens wrote:
>>         I think you're correct-- looks like it needs:
>>
>>         if (!skb)
>>                 return NULL;
>>
>> just before the skb_put(), since an allocation (and failure)
>> could occur in either the igmpv3_newpack() call or in add_grhead().
>>         Also, similar code in net/ipv6/mcast..c.
>>
>>         Will you be submitting the patch?
> 
> One box here can semi-reliably reproduce oops which is attributed to
> these allocation failures. I'll tell if patch works or not soon.

I also think this "if" is needed there and hope you
are right but, actually, skb allocating errors
shouldn't be so semi-reliable.

I don't know what is the kernel version of this box,
but probably another reason could be in_device not
fully initialized, so you could check for David's
Stevens patch to devinet.c.

Regards,
Jarek P.